function ICP_example_complete()
% Iterative closes point example with all options applyed 
%
% Author -  Ernesto Homar Teniente Avilés
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 04/2011
%           Version 1.0
%
% Usage:
%
%  ICP_example_complete()



addpath(genpath('Libs'))
sp =filesep;
icpres_savedir = [sp 'home' sp 'ehomar' sp 'Experiments' sp 'Helena' sp ...
          'IJRR'];

%
        
infoAboutEXPMat.process.scans = 20;
nPairs =  infoAboutEXPMat.process.scans-1 ;

for i=1:nPairs
    ii = i+1;
    pairsList(i,:)  = [i ii];
end


clc
close all
clear Result;
ini=1;
last = size(pairsList,1);
 
maxn = last-ini+1;
Result(1:maxn) = struct('Rt',[],...
                'error',struct('last', [],'hist', []),...
                'pairs',[]);
              
s =filesep;
basepath = ['data' s 'points_set_a'];
posepath = ['data' s 'poses' s];
basename = [basepath s 'scan3D_'];

close all
icp_config();
profile on
l = 0;
for i=ini:last
    fprintf('ICP running : %d \n', l+1);
    j = pairsList(i,1);
    k = pairsList(i,2);
    figRef = sprintf('%d %d', [j k]);
    fprintf('Clouds : %d %d \n', [j k]);
    l = l+1;
    % Creating file names for the required information
    ii =  sprintf('%04u',j);
    filePart = [ ii '.txt'];
    t.scan.points = [basename 'points_' filePart];
    t.scan.normals = [basename 'normals_' filePart];
    t.scan.planesError = [basename 'planesError_' filePart];
    ii =  sprintf('%04u',k);
    filePart = [ ii '.txt'];
    t1.scan.points = [basename 'points_' filePart];
    t1.scan.normals = [basename 'normals_' filePart];
    t1.pose = [posepath 'pose_local_' filePart];
    % Execute ICP for cloud j and k
    [Result(l).Rt Result(l).error.cov Result(l).error.hist ]= icp3Drun( ...
                      importDataTxt(t.scan.points,'Scan3DPoints'),    ...
                      importDataTxt(t1.scan.points,'Scan3DPoints'),   ...
                      importDataTxt(t1.pose ,'Pose'),                 ...
                      'Normals',{                                     ...
                      'RefNormals',                                   ...
                      importDataTxt(t.scan.normals,'Scan3DNormals'),  ...
                      'QueryNormals',                                 ...
                      importDataTxt(t1.scan.normals,'Scan3DNormals'), ...
                      'MaxAngle', maxAngle},                       ...
                      'Planes',{                                      ...
                      'RefPlanesError',                               ...
                      importDataTxt(t.scan.planesError,'Scan3DPlanError'),...
                      'PlanesTreshold', errTrPlanes,                  ...
                      },                                              ...
                      'MatchMetric', matchtype,                       ...
                      'MaxIterations',maxiter,                        ...
                      'DistanceFilterSigma',dsigma_,                   ...
                      'MinMSE', mindk2,                               ...
                      'MSETreshold', errTr,                           ...
                      'Mb_L', L,                                      ...
                      'MSEType',msetype,                              ...
                      'NNSearch', NNs, ...
                      'Plot',i, ...
                      'TextDisplay',0,...
                      'BoxSize',boxsize);
                      %
    Result(l).pairs = [j;k]; 

end
profile viewer


icp_plot_results();


% icpres_savedir =  '.';
% icpSaveResults(Result, icpres_savedir)


