
function ICP_example_simple()

% Iterative closes point example using defaults, no filtering, GLTree and
% metric point-to-point for correspondeces search
%
% Author -  Ernesto Homar Teniente Avilés
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 04/2011
%           Version 1.0
%
% Usage:
%
%  ICP_example_simple()


addpath(genpath('Libs'))
      
infoAboutEXPMat.process.scans = 20;
nPairs =  infoAboutEXPMat.process.scans-1 ;

nonconsLP.max =4;
tmp =0; c= 1; a=0;
for i=1:nonconsLP.max
  tmp = tmp+i;
end

nonconsLP.n = nPairs*nonconsLP.max-tmp;% non consecutive lineal pairs
pairsList = zeros(nPairs,2);

for i=1:nPairs
    ii = i+1;
    pairsList(i,:)  = [i ii];
end


%
clc
close all
clear Result;
ini=1;
last = 4;size(pairsList,1);
 
maxn = last-ini+1;
Result(1:maxn) = struct('Rt',[],...
                'error',struct('last', [],'hist', []),...
                'pairs',[]);
              
s =filesep;
basepath = ['data' s 'points_set_a'];
posepath = ['data' s 'poses' s];
basename = [basepath s 'scan3D_'];

close all

icp_config();
profile on
l = 0;

for i=ini:last
    fprintf('ICP running : %d \n', l+1);
    j = pairsList(i,1);
    k = pairsList(i,2);
    figRef = sprintf('%d %d', [j k]);
    fprintf('Clouds : %d %d \n', [j k]);
    l = l+1;
    % Creating file names for the required information
    ii =  sprintf('%04u',j);
    filePart = [ ii '.txt'];
    t.scan.points = [basename 'points_' filePart];
    t.scan.normals = [basename 'normals_' filePart];
    t.scan.planesError = [basename 'planesError_' filePart];
    ii =  sprintf('%04u',k);
    filePart = [ ii '.txt'];
    t1.scan.points = [basename 'points_' filePart];
    t1.scan.normals = [basename 'normals_' filePart];
    t1.pose = [posepath 'pose_local_' filePart];
    % Execute ICP for cloud j and k
    [Result(l).Rt Result(l).error.cov Result(l).error.hist ]= icp3Drun( ...
                      importDataTxt(t.scan.points,'Scan3DPoints'),    ...
                      importDataTxt(t1.scan.points,'Scan3DPoints'),   ...
                      importDataTxt(t1.pose ,'Pose'));
                      %
    Result(l).pairs = [j;k]; 

end
profile viewer


icp_plot_results();


%% Save results
% icpres_savedir =  '.';
% icpSaveResults(Result, icpres_savedir)


