function ICP_example_simple_semantic()

% Iterative closes point example with default options for semantic data
%
% Author -  Ernesto Homar Teniente Avilés
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 04/2011
%           Version 1.0
%
% Usage:
%
%  ICP_example_simple_semantic()


addpath(genpath('Libs'))
sp =filesep;
icpres_savedir = [sp 'home' sp 'ehomar' sp 'Experiments' sp 'Helena' sp ...
          'IJRR'];

%
        
infoAboutEXPMat.process.scans = 5;
nPairs =  infoAboutEXPMat.process.scans-1 ;
%%
nonconsLP.max =4;
tmp =0; c= 1; a=0;
for i=1:nonconsLP.max
  tmp = tmp+i;
end

nonconsLP.n = nPairs*nonconsLP.max-tmp;% non consecutive lineal pairs
nPairs2 = nonconsLP.n+nPairs;
pairsList = zeros(nPairs,2);

for i=1:nPairs
    ii = i+1;
    pairsList(i,:)  = [i ii];
end


%%
clc
close all
clear Result;
ini=1;
last = size(pairsList,1);
 
maxn = last-ini+1;
Result(1:maxn) = struct('Rt',[],...
                'error',struct('last', [],'hist', []),...
                'pairs',[]);
              
s =filesep;
basepath = ['data' s 'points_set_semantic'];
posepath = ['data' s 'poses' s];
basename = [basepath s 'scan3D_'];

close all

icp_config();
profile on
l = 0;


for i=ini:last%%size(pairsList,1)%ini+(size(N,2)-1)  last
    fprintf('ICP running : %d \n', i);
    j = pairsList(i,1);
    k = pairsList(i,2);
    figRef = sprintf('%d %d', [j k]);
    fprintf('Clouds : %d %d \n', [j k]);
    l = l+1;
    % Creating file names for the required information
    ii =  sprintf('%04u',j);
    filePart = [ ii '.txt'];
    t.scan.points.h = [basename 'points_h_' filePart];
    t.scan.points.v = [basename 'points_v_' filePart];
    t.scan.normals.h = [basename 'normals_h_' filePart];
    t.scan.normals.v = [basename 'normals_v_' filePart];
    t.scan.planesError.h = [basename 'planesError_h_' filePart];
    t.scan.planesError.v = [basename 'planesError_v_' filePart];
    ii =  sprintf('%04u',k);
    filePart = [ ii '.txt'];
    t1.scan.points.h = [basename 'points_h_' filePart];
    t1.scan.points.v = [basename 'points_v_' filePart];
    t1.scan.normals.h = [basename 'normals_h_' filePart];
    t1.scan.normals.v = [basename 'normals_v_' filePart];
    t1.pose = [posepath 'pose_local_' filePart];
    % Execute ICP for cloud j and k
    [Result(l).Rt Result(l).error.cov Result(l).error.hist ]= icp3Drun( ...
                      importDataTxt(t.scan.points,'Scan3DPointsSemantic'),    ...
                      importDataTxt(t1.scan.points,'Scan3DPointsSemantic'),   ...
                      importDataTxt(t1.pose ,'Pose'));
                      %
    Result(l).pairs = [j;k]; 
    % TODO: Save the results at once
end


icp_plot_results();


%% Save results
% icpres_savedir =  '.';
% icpSaveResults(Result, icpres_savedir)
