% CONVTHEO
% Convergence constrains for the ICP
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 08/2009
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%       [loop dk2iter]= convTheo(ek2,dk2,lstdk2,iter, maxiter)
%       
% Variables:
%   Input:
%
%   Outputs:
%       loop    - an integer, value retunerd according with the condition
%                   1 -
%                   2 - the algorithm has converged
%                   3 - a divergence confition occured,
%                       lstdk2-dk2 < -1.5*config.conv.errTr
%                   4 - a divergence condition occured, ek2-dk2 <= 0
%                   5 - config.conv.maxiter reached
%
%       dk2iter - a real, MSE from the las iteration
%       count   - an integer, number of times that some condition happens
%
%   Globals:
%       config.conv.mindk2  - an real,minimum square error
%       config.conv.maxiter - an integer,maximun number of iterations
%       config.conv.miniter - an integer,
%       config.conv.errTr   - an real,diferences between ek2 and dk2
%

%% Code
function [loop dk2iter]= convTheo(ek2,dk2,...
                                  lstdk2,mindk2,...
                                  mseTreshold, ...
                                  iter, maxiter)

% temp = ek2 -dk2 ;
% fprintf('diferencia e2 = %2.5f  %2.5f %2.5f\n', [temp ek2 dk2])
dk2iter = dk2;
loop =0;
if iter == maxiter
    loop =5;
    count = zeros(3,1);
end
if (dk2 <= mindk2) && (abs(ek2-dk2) < mseTreshold)
    % count(1,1) = lstcount(1,1)+1;
    % count(2,1) = 0;
    % count(3,1) = 0;
%     if iter >= miniter ;
        loop = 2;
%     end
    return
end
% The data set diverges
% if (lstdk2-dk2 < -1.5*config.conv.errTr) && (iter>1)
%     count(1,1) = 0;
%     count(2,1) = 0;
%     count(3,1) = lstcount(3,1)+1;
%     if count(3,1) == 3
% 		loop = 3;
% 		count(3,1) = lstcount(3,1)+1;
%     end
%     return
% elseif (ek2-dk2 <= 0 ) && (iter>1)
%     count(1,1) = 0; %lstcount(1,1);
%     count(2,1) = lstcount(2,1)+1;
%     count(3,1) = 0;%lstcount(3,1);
%     if count(2,1) == 3
%         loop = 4;           
%         count(2,1) = lstcount(2,1)+1;
%         return
%     end
% % maximun iteration reached
% else
%     count = zeros(3,1);
%     % count = lstcount;
% end