% ICPMSE
% Given two data set with the same size .Calculates mean square error 
% based on [BESL92], 
%
%% Description
%
% Author - 	
%       Ernesto Homar Teniente Aviles
%       CONACYT Schoolar
%       Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 07/2010
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage
%   err2 = MeanSqError(data1,data2)
%
% Variables:
%   Inputs 
%       data1   - Reference Points
%       data2   - Model Points, the cloud to transform
% Outputs: 
%       err2  - a integer, mean square error
%


%% Code
function err2 = icpMSE(data1,data2)
out = nargout;
[n1 m1] = size(data1);
[n2 m2] = size(data2);

if n1 ~= n2
    error('Mismatching number of elements betwen data1 and data2 ')
end
if m1 ~= 3 || m2 ~= 3
    error('Not a valid dimension for data1 or data2 ')
end

% Computing the Mean Square Errors

for i = 1:Np
    % Computing the (x,y,z) square errors
    err2 = err2 + norm(data1(i,:)-data2(i,:))^2;
end
% Computing the mean square errors
 err2 = err2/Np;
