% Filter the repeated index from a NN search using a minimun distance
% criteria

% inx  = 3xn matrix, correspondece matrix
%       inx(1,:) = matched points with query points
%       inx(2,:) = query points list
%       inx(3,:) = distance between the index representing the points

function [inx_ varargout] =  icpFilterRepeatedIndex(inx)

% Modificada el 20105, ver la eficacia de esta implementacion
[tmp, inx_tmp] = sort(inx(1,:));
nninx_new = inx(:,inx_tmp);

tmp =  localFilter(nninx_new(1,:), nninx_new(3,:));
inx_(1,:) = nninx_new(1,tmp);
inx_(2,:) = nninx_new(2,tmp);
inx_(3,:) = nninx_new(3,tmp);

% [tmp, inx_tmp] = sort(inx_(2,:));
% nninx_new = inx_(:,inx_tmp);
% tmp = localFilter(nninx_new(2,:),nninx_new(3,:));
% inx_ =[];
% inx_(1,:) = nninx_new(1,tmp);
% inx_(2,:) = nninx_new(2,tmp);
% inx_(3,:) = nninx_new(3,tmp);

% return the local index
if nargout == 2
  varargout(1) = {tmp};
end 

function rinx =localFilter(inx,dist_)


[u inx_.first ignore] = unique(inx,'first');
[u inx_.last ignore] = unique(inx,'last');
inx_.n = inx_.last-inx_.first+1;
% 2.2 Encontrar los indices en nninx(1) repetidos mas de una vez o no
[ignore inx_.rep ] = find(inx_.n > 1);
[ignore inx_.once] = find(inx_.n == 1);
% 2.3 Encontrar los indices repetido en (nninx(1))

%% 3 para inx_.rep encontrar aquellos con la minima distancia
j = size(inx_.rep,2);
inx_.repfil = zeros(1,j);
for i=1:j
  [ignore tmp_] = min(dist_(inx_.first(inx_.rep(i)):inx_.last(inx_.rep(i))));
  inx_.repfil(i) = inx_.first(inx_.rep(i))+tmp_-1;
end
rinx = [inx_.repfil inx_.once];
