% GETSETPOINTPRIMA -
% Compute the data used for the minimization process
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 12/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
%
%% Usage:
%   [data_prima c_data]= getSetPointPrima(data)
%
% Variables :
%
% Inputs:
% 
%   data - a 3 x n matrix, points
% 
% Outputs
%
%	c_data	- a  3x1 vector,
%	data_prima	- a 3xn vector,

%% Code

function [data_prima c_data]= getSetPointPrima(data)

c_data = getCentroid(data);
data_prima = [data(1,:)-c_data(1);
              data(2,:)-c_data(2);
              data(3,:)-c_data(3)];

