%% MbICP6Dnns 
% Finds the filtered correspondences given two 3D data sets , it could be
% donde using only a point-to-point o a point-to-plane metric
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - 08/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%           
% Usage:
%   indexs = correspond(S,percent,dHist,plot,errormetric)
%
% Variables
%
% Inputs :
%
% Outputs:
%   nnptd - a 
%
% 
% Options:
%

%% Code
function nnpts = MbICP6Dnns(S,percent)


if percent >1
    error('Not a valid percentage value, it most be a value from 0-1')
end

global config; 

% Find the nearest neighbor using the ANN library
S(2).data(:,4:6) = carte2esf(S(2).data);
% Matching, miminum ditance between P_m and {S_(n,P_ m)}
S(2).data = sortrows(S(2).data,6);
% Neares Neighbor Search
pairIndx = NNSSF(S(1).data ,S(2).data);
% Recover correspondent points from the indexs           
nnpts = indx2pts(S(1).data,S(2).data,pairIndx);
% Filter the repeated points
nnpts =filRepPtsANN(nnpts);
% Filter the point with maximum distance 
nnpts =filPtsMaxD(nnpts,2.5);
%nnpts =filPtsMaxD(nnpts,distr);
% nnidx =sortrows(nnidx,2);
% Filter the most  x% represntative data 
% nnpts = filtMostRepData(nnpts,7,percent,dhist,plot);
