% nninx - nx3 matrix, 
%       - (:,1) query point index, 
%       - (:,2) reference points resulting NN index, 
%       - (:,3) distances betwwen matched points 

function  nninx = icp3DgetNN(Xr,Xq,kNNmethod)


kNNmethod = 'GLTree3D';

% ANN return the index (nninx) for the queryPts correspondet with the
% i-esim point of refPts, d is the distance between them.

% For each point in Xq (say the i-th point, that is Xq(:,i)), the
% function finds k nearest points to it in Xr. The indices of these
% i-esim point of queryPts, d is the distance between them.
switch kNNmethod 
  case 'ANN'
    [nninx nnD]= annquery(refPts, queryPts, 1);
  case 'GLTree3D'
    ptrtree=BuildGLTree3D(refPts);
    [nninx nnD]=KNNSearch3D(refPts,qPts,ptrtree,1);
  otherwise
    error('Invalid kNNmethod')
end

% Recover the neigbors in refPts fro the NN found as the new refPts
nninx = buildCorrIndex(nninx, nnD);
