function nnpts = icp3Dpt2plMetric(refPts,queryPts,...
                                  refPlanErr,refNormals,planErrLim,o_inx,...
                                  varargin)
                                
chkvarargin(varargin,2);
onlyplanes = process_options(varargin,...
                             'OnlyPlanes',0);

r3 = size(refPlanErr,2);
jj = r3;
% Correspondeces pt2pt for the hybrid search
if ~onlyplanes
  % Sort planes errors for quick filtering
  [refPlanErr,s_inx] = sort(refPlanErr);
  inxs = refPlanErr<=planErrLim;
  % keep only the data that passed pevious filter
  refNormals4Planes = refNormals(:,s_inx(inxs));
  refPts4Planes =  refPts(:,s_inx(inxs));
  queryPts4Planes = queryPts(:,s_inx(inxs));
  
  inx = size(nonzeros(s_inx(inxs)),1);
 
  % index computation for data tractament
  jj = r3;
%   nnpts = zeros(7,jj);
%   i = jj-inx;
%   j = inx+1;
%   nnpts(1:3,1:(i)) = refPts(:,j:jj);
%   nnpts(4:6,1:(i)) = queryPts(:,j:jj);
%   nnpts(7,1:(i)) = dist3D(refPts(:,j:jj),queryPts(:,j:jj));
  ii = jj-inx;
  j = inx+1;
  t_inx = o_inx(:,j:jj);
  i=0;
  if ~isempty(t_inx)
    [~, l_inx]= icpFilterRepeatedIndex(t_inx);
    i = length(l_inx); % number of points
    v_inx = j:jj;
    v_inx = v_inx(l_inx);
    nnpts(1:3,1:(i)) = refPts(:,v_inx);
    nnpts(4:6,1:(i)) = queryPts(:,v_inx);
    nnpts(7,1:(i)) = dist3D(refPts(:,v_inx),queryPts(:,v_inx));
    jj = r3-(ii -length(l_inx));
  end
  
else
  % this if we use onlu well defined planes
  i=0;
  
  refNormals4Planes = refNormals;
  refPts4Planes =  refPts;
  queryPts4Planes = queryPts;

  nnpts = zeros(7,jj);

end

j = i+1;
[ansRefPt d] = pointPlane2Point(refPts4Planes,refNormals4Planes,queryPts4Planes);

nnpts(1:3,j:jj) = ansRefPt ;
nnpts(4:6,j:jj) = queryPts4Planes;
nnpts(7,j:jj) = abs(d);

filtrepts =1;
% Filter repeated points
if filtrepts
%   d = dist3D(nnpts(1:3,:), zeros(3,r3));
%   [d inx ]=sort(d);
%   nnpts = nnpts(:,inx);
%   [u v m] = unique(d);
  [u, v, m] = unique(nnpts(1,:));
  nnpts = nnpts(:,v);
end
  




