function nnpts = icp3Dpt2plMetric2(refPts,queryPts,...
                                  refPlanErr,refNormals,planErrLim,...
                                  varargin)
                                
chkvarargin(varargin,2);
onlyplanes = process_options(varargin,...
                             'OnlyPlanes',0);

r3 = size(refPlanErr,2);

% Sort planes errors for quick filtering
[refPlanErr sortInx] = sort(refPlanErr);
% Sort the points acording with previus planes error sort
refPts =  refPts(:,sortInx);
queryPts = queryPts(:,sortInx);
refNormals = refNormals(:,sortInx);
% filter adjust planes error with the maximum threshold giveb by planErrLim
% find the first index bigger than planErrLim in refPlanErr
inx = appBinSearch(refPlanErr,0,planErrLim);
% keep only the data that passed pevious filter
refNormals4Planes = refNormals(:,1:inx);
refPts4Planes =  refPts(:,1:inx);
queryPts4Planes = queryPts(:,1:inx);

% Correspondeces pt2pt for the hybrid search
if ~onlyplanes
  jj = r3;
  nnpts = zeros(7,jj);
  i = jj-inx;
  j = inx+1;
  nnpts(1:3,1:(i)) = refPts(:,j:jj);
  nnpts(4:6,1:(i)) = queryPts(:,j:jj);
  nnpts(7,1:(i)) = dist3D(refPts(:,j:jj),queryPts(:,j:jj));
else
  i=0;
  jj =r3-inx; 
  nnpts = zeros(7,jj);
end

j = i+1;
[ansRefPt d] = pointPlane2Point(refPts4Planes,refNormals4Planes,queryPts4Planes);

nnpts(1:3,j:jj) = ansRefPt ;
nnpts(4:6,j:jj) = queryPts4Planes;
nnpts(7,j:jj) = abs(d);




