%% clearSensorCenter
% rename as clearAroundPose
% Given a delta value, erase from de data set all de values about the delta
% from the origin (x,y)

%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 5/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% Usage
%
%
% Inputs
%   Data  - a n x 3 matrix, data to filter
%   Pose  - a 1 x 3 vector, robot's pose (x,y,z)
%   Delta - a positive real, Max&min valid distance arund the x and y
%
% Outputs
%   fildata - a m x 3 matrix, filtered data
%

%% Code
function fildata = clearSensorCenter(Data,Pose, Delta)

% Cambiar el metodo pues esto lo que hace es la busqueda en una esfera que
% no es lo mas correcto, lo suyo seria en un cilindro con un eje que pasa
% por el centro del sensor en el eje z
npts = size(Data,2);
center = Pose(:,ones(1,npts));
d = dist3D(center,Data);
% inx = find(d>=Delta);
fildata = Data(:,d>=Delta);
inx = find(d<Delta);
inx_ =  Data(3,inx)>0.1;

fildata =[fildata  Data(:,inx(inx_))];


% Data = sortrows(Data,1);
% % Filter x values
% [lindxx uindxx]= windowBinSearch(Data(:,1),Delta,Pose(1,1));
% fildata = [Data(1:lindxx-1,:);Data(uindxx+1:end,:)];
% 
% % Filter y values
% tofil = Data(lindxx:uindxx,:);
% tofil = sortrows(tofil,2);
% [lindxx uindxx]= windowBinSearch(tofil(:,2),Delta,Pose(1,2));
% % filty = [tofil(1:lindxx-1,:);tofil(uindxx+1:end,:)];
% if lindxx ~= 1
%     fildata = [fildata; tofil(1:lindxx,:)];
% end
