% FILREPPTSANN 
% Delte points with more tha one nearest neigbor assignament
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
% Last change - 10/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%       filPts =filterRepPoints(points)
%
% Variables:
%   Input: 
%       Points  - a n x 7 matrix, containig query points, their
%       correspondent nn nnd distance
%                   colum(1:3) - query points
%                   colum(4:6) - nn points
%                   colum(7)   - distance between points
%
%   Outputs:
%       filPts  - a m x 7 matrix, with the filtered points. 
%   
%% Code
function filPts =filRepPtsANN(points)

% Order the returned close point by the x coordinate
points = sortrows(points,4);
%%
n = size(points,1);
filPts(1,:) = points(1,:);

j = 1;
for i = 2: n
    diff = points(i,4:6) - points(i-1,4:6);
    if diff(1,:) == [0 0 0]
        if points(i,7) < points(i-1,7)
           filPts(j,:) = points(i,:);
        end
        else
        j = j+1;
       filPts(j,:) = points(i,:);
    end
end

