%% filtHist
% Function to filter the most representative data using an histogram
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Sholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 10/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%
%   filterhist = filtHist(histo, totalElem , percentage)
%
% Variables
%   Inputs
%       histo       - an histogran result, Histogram to filter
%       totalElem   - an integer, Number of elements in the histogram
%       percentage  - a decimal between 0- 1, percentage to return
%
%   Outputs
%       filterhist  - filtered data

%% Code
function filterhist = filtHist(histo,totalElem,percentage)
if percentage >1
    error('Not a valid percentage value, it most be a value from 0-1')
end
% tmp_index =[];
filterIndex = [];
tmp_index =[];
% Findig the biggest element on hist(1,:)
[n_max(1) n_max(2)] = max(histo(1,:));
suma = n_max(1);
% index were the maximun number of elements is
ihist_max = n_max(2);
% Is the biggest element on hist(1,:) the percentage wished?
porcen = suma/totalElem;
% fprintf('Filter Started\n')
if porcen >= percentage
%     fprintf('pocen_w > 0.7 \n');
    % return the index from histo in wich the maximum value is and the
    % maximum value
    filterhist = [ihist_max; histo(2,ihist_max)];
    return
else
    filterIndextemp = ihist_max;
    hist_size = size(histo,2);
    j = 0;
    while (porcen < percentage)
        % stores index from the selected data from the histogram
        filterIndextemp = [filterIndextemp tmp_index];
        tmp_index =[];
        j = j+1;
        jh = ihist_max-j;
        jj = ihist_max+j;
        % searchs if there are elements at the left side of j
        if jh > 0
            suma = suma + histo(1,jh);
            tmp_index = [tmp_index jh];
        end
       % searchs if there are elements at the right side of j
        if jj <= hist_size
            suma = suma + histo(1,jj);
            tmp_index = [tmp_index jj];
        end
        porcen = suma/totalElem;
        if (jh < 0 & jj > hist_size)
            error('filtHist.m : Index out of bounds for jh and jj ')
        end
    end
    filterhist = sort(filterIndextemp);
    n = size(filterhist ,2);
        for i=1:n
           % stores in  filterhist(2,i) the correpondent median value, 
           % for each  filterhist(1,i), from the histo
           filterhist(2,i) = histo(2,(filterhist (1,i)));
        end     
    return
end
