% FILTERREPPOINTS
% Find if from a poitns set are reapeted points 
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - 10/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%       filPts =filterRepPoints(points)
%
% Variables:
%   Input: 
%       Points  - a n x 3 matrix, containig the points 
%
%   Outputs:
%
%% Code
function filPts = filterRepPoints(points)
% Order the returned close point by the x coordinate
points = sortrows(points,1);
%%
n = size(points,1);
filPts(1,:) = points(1,:);

%%
j = 2;
for i = 2: n
    diff = points(i,:) - points(i-1,:);
    if diff(1,:) ~= [0 0 0]
       filPts(j,:) = points(i,:);
       j = j+1;
    end
end

inx = unique(points);
