%% medianfilter
% MEDIAN FILTER ALGORITHM
% [GUT99]
% 
% for i := 0 to numpoints(z) 1 do 
%   to modify 
%   to modify
%   if d1 or d2 > distance_threshold
% 		p := n-th-scanpoint(z; i) 
% 		for j := 0 to MEDIAN-NUM-POINTS 1 do 
% 			k := (i + j - MEDIAN-NUM-POINTS/2) mod numpoints(s) 
% 			p_k := n-th-scanpoint(z; k) 
% 			d(j) := distance-value(p_k ) 
% 		endfor 
% 		d_median := median(d) 
% 		n-th-scanpoint(z' ; i) := (angle-value(p); d median ) 
% 	endfor 
% 	return z'

%% Description 
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 06/10/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage
%   zf = medianfilter(z,mednumpoints)
%
% Varibles:
%	Inputs:
%		z - a n x 3 matrix, data to filter
%		mednumpoints - a odd integer, number of point to the 
%					   median filter
%
%   Outputs: 
%       zf - a mx 3 matrix, filtered data
%% Code
% Based on the above algorithm
function zf = medianfilter(z,mednumpoints)



fprintf('Median Filter...Running...');

numpoints = size(z,1);

zf = zeros(numpoints,1);

for i =1:numpoints

    % attemp to avoid round off corners

    % d1 = abs(z(i-1)-z(i));

    % d2 = abs(z(i)-z(i+1));

    % if (d1 > d_threshold | d2 > d_threshold )

        for j= 1:mednumpoints
%             k = mod (i+j-floor(mednumpoints/2)+1, numpoints);
            k = floor(i+j-mednumpoints/2);
            if (k > 0 && k < length(z))
                p(j) = z(k);
             end

        end

%         p(0.5+mednumpoints/2

        p = sort(p);

%          zf(i,:) = [zf;p(0.5+mednumpoints/2)];

        zf(i,:) =  mean(p); %p(0.5+mednumpoints/2);

%         p_median = mean(p);

%          zf(i)=p_median;

%     end



end

fprintf('DONE');

return