% PORCENTFILT
% Function to filter the most representative data acordingly with a
% filtered histogram 
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 5/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage
%       filtdat= porcentFil(dat2filt,filthist,histo,dcol)
% 
% Variables:
%   Inputs
%       dat2filt    - a n x m matrix, data to filter
%       filthist        - the result from hist_filt
%       histo           - an histogram
%       dcol            - an integer, colum in dat2filt belonging tho the
%       data to filter, usually a distance
%   Outputs
%       filtdat      - a n1 x m matrix, filtered data
%

%% Code
function  filtdat= porcentFil(dat2filt,filthist,histo,dcol)
filtdat =[];
i_fdata = size(filthist,2);
% min_i_fdata = 1;
% max_i_fdata = 10;
min_i_fdata = filthist(1,1);
max_i_fdata = filthist(1,i_fdata);
if min_i_fdata ~= 1
    amin_i_fdata = min_i_fdata-1;
    % Compute the minimun value
    temp = (histo(2,min_i_fdata)-histo(2,amin_i_fdata))/2;
    min_cota = filthist(2,1) - temp;
else
    min_cota = 0;
end
%%
if max_i_fdata < size(histo,2)
    smax_i_fdata = max_i_fdata +1;
    % compute teh maximum value
    temp = (histo(2,smax_i_fdata)-histo(2,max_i_fdata))/2;
    max_cota = filthist(2,i_fdata) + temp;
else
    max_cota = histo(2,i_fdata);
end
%%
% end
s_dataset = size(dat2filt,1);
for i=1:s_dataset
   if (min_cota <= dat2filt(i,dcol) && dat2filt(i,dcol)<= max_cota)
       filtdat = [filtdat ; dat2filt(i,:)];
   end
end
