% FILTPTSMAXD
% From all the correspondences keep only those wich distance is less than
% 2.5 sigma 
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change -    08/ 2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%       filPts =filPtsMaxD(points,maxDis)
%
% Variables:
%   Input: 
%       Points  - a n x 7 matrix, containig query points and their
%       correspondent nn, also the distance between them
%                   colum(1:3) - query points
%                   colum(4:6) - nn points
%                   colum(7)   - distance between points
%
%   Outputs:
%       filPts  - a m x 7 matrix, with the filtered points. 
% 

%% Code
% Utilizar 2.5 sigma como la maxima distancia permitida
function filPts =filPtsMaxD(points,max_dist)

points = sortrows(points,7);

indx = appBinSearch(points(:,7),0.001,max_dist);
% agregar tolerancia como una variable o usar la otra busqueda binaria
filPts = points(1:indx-1,:);
