% FILTPTSMAXDISTSIGMA
% From all the correspondences keep only those wich distance is less than
% sigma*mean(distances)
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change -    08/ 2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%       filPts =filPtsMaxD(points,maxDis)
%
% Variables:
%   Input: 
%       Points  - a n x 7 matrix, containig query points and their
%       correspondent nn, also the distance between them
%                   colum(1:3) - query points
%                   colum(4:6) - nn points
%                   colum(7)   - distance between points
%
%   Outputs:
%       filPts  - a m x 7 matrix, with the filtered points. 
% 

%% Code
% Utilizar 2.5 sigma como la maxima distancia permitida por default
function [pts varargout] =filPtsMaxDistSigma(points,sigma)

if nargin <2
  sigma =2.5;
end

maxdist_ = sigma*mean(points(7,:));
if nargout==2
  [ignore inx ]= find(points(7,:)<=maxdist_);
  pts = points(:,inx);
  varargout(1) = {inx};
else
  pts = points(:,points(7,:)<=maxdist_);
end