% MAXDIST
% Function to determine de maximun distance for the points in the (x,y)
% plane using binary search.

%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 5/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% Usage
%
%
% Inputs
%   data  - a nx3 matrix, data to filter
%   oPos  - a 1x3 vector, robot's pose (x,y,z)
%   Delta - a positive real, Maximin valid distance
%
% Outputs
%   redData - a mx3 matrix,filtered data
%

%% Code
function fildata = maxDist(data,oPos, delta)

data = eraseUpperPoints3D(data,'x',delta,'SensorOrigin', oPos);
data = eraseUpperPoints3D(data,'y',delta,'SensorOrigin', oPos);
data = eraseLowerPoints3D(data,'x',delta,'SensorOrigin', oPos);
fildata = eraseLowerPoints3D(data,'y',delta,'SensorOrigin', oPos);
