% MAXDIST2
% Function to determine de maximun distance for the points in the (x,y)
% plane. Brute force
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - Dic, 2008
%
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage
%      redData = maxDist2(data,pose, delta)
%
% Varibles:
%
%   Inputs
%       data  - a n x 3 matrix
%       pose  - a 1 x 3 vector, robot pose
%       delta - a positive integer, maximum valid distance
%
%   Outputs
%       reddata   - a n1 x 3 matrix, data filtered

%% Code
function reddata = maxDist2(data,pose, delta)

reddata= zeros(100,3);
j = 1;
xdeltaup = (delta + pose(1,1));
ydeltaup = (delta + pose(1,2));
xdeltadown = (pose(1,1)-delta);
ydeltadown = (pose(1,2)-delta);

for i = 1:size(data,1)
%     nor = ((data(i,1)-pose(1,1))^2+(data(i,2)-pose(1,2))^2+...
%         (data(i,3)-pose(1,3))^2)^0.5;
% fprintf( 'Zi : %d , Zodelta: %d \n',[data(i,3) Zodelta ])
    if  (xdeltadown<=data(i,1)) & (data(i,1) <= xdeltaup)&...
            (ydeltadown <=data(i,2))&(data(i,2) <= ydeltaup)
        reddata(j,:) = data(i,:);
        j = j+1;
    end
end
