% RANDOMSAMP
% Given a 3D data set perform a random sampling, returning m points
%
%% Description:
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 08/2009
%
% Usage
%	SampledData = randomSamp(data,m)
%
% Inputs:
% 	data 	- a 3xn matrix, data to be sampled
% 	m 		- a integer, size sampled data
%
% Outpus:
% 	SampledData - a m X 3 matrix, containg the result of the random sampling
%

%% Code:

function SampledData = randomSamp(data,m)

n= size(data,2);
if m < n
	inx=sort(ceil(rand(m,1)*n));
	SampledData = data(:,inx); 
	else
		SampledData=data;
end



