% BOXLIST
% Compute the number of pts in each box
% 
% Description
% Author - 	
%       Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%       Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 11/2010
%
% Usage 
% 	structure = boxesList(data,boxsize)
%
% Variables:
%
% Inputs;
%   data    - a 3xn matrix, data to be sampled
%   boxsize - +real, size of the box
%
% Outputs :
%   structure - 

%% Code
function B = boxesAcka(data,boxsize)

%fprintf('Crating boxes list...')
n = size(data,2);

% Find de minimun x, y and z to create thea cube
b = boxBounds(data);
% Find how many boxes do we need per each axis
M.x = ceil((b.max.x-b.min.x)/boxsize);
M.y = ceil((b.max.y-b.min.y)/boxsize);
M.z = ceil((b.max.z-b.min.z)/boxsize);

B = zeros(M.x,M.y,M.z);

for i=1:n
    box.x = ceil((data(1,i)-b.min.x)/boxsize);
    box.y = ceil((data(2,i)-b.min.y)/boxsize);
    box.z = ceil((data(3,i)-b.min.z)/boxsize);
    B(box.x,box.y,box.z) = B(box.x,box.y,box.z)+1;
end

%fprintf('DONE \n')