% BOXLIST
% Compute the list with the corresponding box for each point(:,i) in data
% 
% Description
% Author - 	
%       Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%       Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 11/2010
%
% Usage 
% 	structure = boxesList(data,boxsize)
%
% Variables:
%
% Inputs;
%   data    - a 3xn matrix, data to be sampled
%   boxsize - +real, size of the box
%
% Outputs :
%   B - nx3

%% Code
function B = boxesList(data,box_size,varargin)

%fprintf('Crating boxes list...')
n = size(data,2);
% Find de minimun x, y and z to create the cube
if nargin >=3
  if ~isempty(varargin{1})
    b= varargin{1};
    b.delta = b.max-b.min;
  else
    b = boxBounds(data,0.1);
  end
else
  b = boxBounds(data,0.1);
end
ceil(b.delta/box_size);
% B = zeros(n,3);
if length(box_size) == 1
  B(:,1) = ceil((data(1,:)-b.min(1))/box_size)';
  B(:,2) = ceil((data(2,:)-b.min(2))/box_size)';
  B(:,3) = ceil((data(3,:)-b.min(3))/box_size)';
else
  B(:,1) = ceil((data(1,:)-b.min(1))/box_size(1))';
  B(:,2) = ceil((data(2,:)-b.min(2))/box_size(2))';
  B(:,3) = ceil((data(3,:)-b.min(3))/box_size(3))';
end
  
  
  
  

