% BOXLIST
% Compute the list with the corresponding box for each point(:,i) in data
% 
% Description
% Author - 	
%       Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%       Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 11/2010
%
% Usage 
% 	structure = boxesList(data,boxsize)
%
% Variables:
%
% Inputs;
%   data    - a 3xn matrix, data to be sampled
%   boxsize - +real, size of the box
%
% Outputs :
%   structure - 

%% Code
function B = boxesListv2(data,boxsize,delta,varargin)


%fprintf('Crating boxes list...')
n = size(data,2);
% Find de minimun x, y and z to create thea cube
if nargin >=4
  if ~isempty(varargin{1})
    b= varargin{1};
  else
    b = boxBounds(data,delta);
  end
else
  b = boxBounds(data,delta);
end

B = zeros(n,3);
B(:,1) = ceil((data(1,:)-b.min(1))/boxsize)';
B(:,2) = ceil((data(2,:)-b.min(2))/boxsize)';
B(:,3) = ceil((data(3,:)-b.min(3))/boxsize)';

