% GETPLANEEQPARAMETERS -
% Given tre points compute plane equation parameters a,b,c and d 
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 08/2009
% 
% Usage
%       [a b c d] = getPlaneEqParameters(P1,P2,P3)
%
% Varibles:
%   Inputs
%       P1 - a 1x3 vector, first point
%       P2 - a 1x3 vector, second point
%       P3 - a 1x3 vector, third point
% 
%   Outputs:
%       [a b c d] - plane parameters
%
%   Options
%
%
%   Note:
%       Plane equation, ax + by + cz + d = 0

%% CODE

function [a b c d] = getPlaneEqParameters(P1,P2,P3)

n = cross(P1-P2,P1-P3);
a = n(1);
b = n(2);
c = n(3);
d = -(a*P1(1)+b*P1(2)+c*P1(3)) ;
