%% Description:
% Calculates the adjust error between a set of points defining 
% a plane and the plane defined by it's normal
%
%% Usage:
%   error = adjErrPoints2Plane(normal, points, medianPoint)
%
% Variables :
%
% Inputs:
%	normal      - a 3 x 1 vector, plane normal
%	points      - a 3 x n matrix with the points defining the plane
%	medianPoint	- a 3 x 1 vector, median point of the plane
%
% Outputs
%	error		- a real , resulting distance from the point to the 
%					defined by de given normal
%
%% Code
function error = adjErrPoints2Plane(normal, points, medianPoint)

num_Points = size(points,2);
error = 0;
for ii=1:num_Points
	error = error + abs(normal'*(points(:,ii)-medianPoint));
end
error = error/num_Points;