%% Description:
% Calculates the distance between a point and a plane 
% defined by it's normal
%
%% Usage:
%
% d = distPoint2Plane(point,n,p)
%
% Variables :
%
% Inputs:
%	point	- a 3 x 1 vector, point in cartesian
%	n		- a 3 x 1 vector, plane normal
%	p		- a 3 x 1 vector, median plane point
%
% Outputs
%	d		- a real , resulting distance from the point to the 
%					defined by de given normal
%
%% Code
function d = distPoint2Plane(points,n,p)

d = sum(n.*(points-p),1);

% d =dot(n,points-p,1);
% d = dotProduct3D(n,points-p);
% d = n'*(point-p); 
