%initLocal;

%%
syms d
syms n_x n_y n_z;
syms p1_x p1_y p1_z;
syms q_x q_y q_z;
syms Q11 Q12 Q13 Q22 Q23 Q13 Q23 Q33;


n = [n_x; n_y; n_z];
n_transpose = [n_x, n_y, n_z];
q_itranspose = [q_x q_y q_z];
Q = [q11 q12 q13; q12 q22 q23; q13 q23 q33];

d = [p1_x, p1_y, p1_z]*n;

phi = 2*[Q(1,:)*n-d*q_x-(2/n_z)*(Q(3,:)*n-d*q_z)*n_x
        Q(2,:)*n-d*q_y-(2/n_z)*(Q(3,:)*n-d*q_z)*n_y
        n_transpose*n-1];

%% Derivatives dphi/dn_

d_phi_1.dn_x = diff(phi(1,:),n_x);
d_phi_1.dn_y = diff(phi(1,:),n_y);
d_phi_1.dn_z = diff(phi(1,:),n_z);

fprintf('d_phi_1.dn_x = ')
disp(d_phi_1.dn_x)
fprintf('d_phi_1.dn_y = ')
disp(d_phi_1.dn_y)
fprintf('d_phi_1.dn_z = ')
disp(d_phi_1.dn_z)

d_phi_2.dn_x = diff(phi(2,:),n_x);
d_phi_2.dn_y = diff(phi(2,:),n_y);
d_phi_2.dn_z = diff(phi(2,:),n_z);
fprintf('d_phi_2.dn_x = ')
disp(d_phi_2.dn_x)
fprintf('d_phi_2.dn_y = ')
disp(d_phi_2.dn_y)
fprintf('d_phi_2.dn_z = ')
disp(d_phi_2.dn_z)

d_phi_3.dn_x = diff(phi(3,:),n_x);
d_phi_3.dn_y = diff(phi(3,:),n_y);
d_phi_3.dn_z = diff(phi(3,:),n_z);
fprintf('d_phi_3.dn_x = ')
disp(d_phi_3.dn_x)
fprintf('d_phi_3.dn_y = ')
disp(d_phi_3.dn_y)
fprintf('d_phi_3.dn_z = ')
disp(d_phi_3.dn_z)

d_phi.d_n = [d_phi_1.dn_x d_phi_1.dn_y d_phi_1.dn_z 
             d_phi_2.dn_x d_phi_2.dn_y d_phi_2.dn_z 
             d_phi_3.dn_x d_phi_3.dn_y d_phi_3.dn_z];

%% Derivatives dphi/pi_

syms p_ix p_iy p_iz

p_i = [p_ix; p_iy; p_iz];
p_itranspose = [p_ix, p_iy, p_iz];


Q_i = p_i*p_itranspose;

q_ix = p_ix;
q_iy = p_iy;
q_iz = p_iz;


phi_i = 2*[Q_i(1,:)*n-d*q_ix-(2/n_z)*(Q_i(3,:)*n-d*q_iz)*n_x
        Q_i(2,:)*n-d*q_iy-(2/n_z)*(Q_i(3,:)*n-d*q_iz)*n_y
        n_transpose*n-1];

%%

d_phi_1i.dp_ix = diff(phi_i(1,:),p_ix);
d_phi_1i.dp_iy = diff(phi_i(1,:),p_iy);
d_phi_1i.dp_iz = diff(phi_i(1,:),p_iz);

fprintf('d_phi_1i.dp_ix = ')
disp(d_phi_1i.dp_ix)
fprintf('d_phi_1i.dp_iy = ')
disp(d_phi_1i.dp_iy)
fprintf('d_phi_1i.dp_iz = ')
disp(d_phi_1i.dp_iz)

d_phi_2i.dp_ix = diff(phi_i(2,:),p_ix);
d_phi_2i.dp_iy = diff(phi_i(2,:),p_iy);
d_phi_2i.dp_iz = diff(phi_i(2,:),p_iz);
fprintf('d_phi_2i.dp_ix = ')
disp(d_phi_2i.dp_ix)
fprintf('d_phi_2i.dp_iy = ')
disp(d_phi_2i.dp_iy)
fprintf('d_phi_2i.dp_iz = ')
disp(d_phi_2i.dp_iz)

d_phi_3i.dp_ix = diff(phi_i(3,:),p_ix);
d_phi_3i.dp_iy = diff(phi_i(3,:),p_iy);
d_phi_3i.dp_iz = diff(phi_i(3,:),p_iz);
fprintf('d_phi_3i.dp_ix = ')
disp(d_phi_3i.dp_ix)
fprintf('d_phi_3i.dp_iy = ')
disp(d_phi_3i.dp_iy)
fprintf('d_phi_3i.dp_iz = ')
disp(d_phi_3i.dp_iz)

d_phii.dp_i = [d_phi_1i.dp_ix d_phi_1i.dp_iy d_phi_1i.dp_iz 
              d_phi_2i.dp_ix d_phi_2i.dp_iy d_phi_2i.dp_iz 
              d_phi_3i.dp_ix d_phi_3i.dp_iy d_phi_3i.dp_iz];
          
% d_phi.dp_iJdztdqtmp(:,3*(i-1)+1:3*i) = d_phii.dp_i;
