% NORMALSANGLE
% Given two normal vector, return the angle in radians between them
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - Feb, 2009
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage:
%      angle = normalsAngle(n1,n2)
%
% Variables
%   Inputs :
%       n1    - a 1 x 3 vector, first normal 
%       n2    - a 1 x 3 vector, second normal
%
%   Outputs:
%       angle - an integer, angle between the normals
%
%% Code

function angle = normalsAngle(n1,n2)

% Angle between the normals
% angle = acos((n1*n2')/(norm(n1)*norm(n2)))

angle = acos(normalsCos(n1,n2));
