% NORMALSCOS
% Given two normal vector, return the cosine of the angle in radians
% between them
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - Feb, 2009
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage:
%      cosA = normalsCos(n1,n2)
%
% Variables
%   Inputs :
%       n1    - a 1 x 3 vector, first normal 
%       n2    - a 1 x 3 vector, second normal
%
%   Outputs:
%       cosA - an integer, cosine of the angle  between the normals
%
%% Code

function cosA = normalsCos(n1,n2)

% Angle cosine between the normal

cosA = (n1*n2')/(norm(n1)*norm(n2));
