% PROJPOINT2PLANE
% Computes the projection point of a point to a given plane 
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 05/2009
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage
%       ansPt = projPoint2Plane(normal,points)
% 
% Variables:
%   Input:
%
%       normal  - a 3 x 1 vector, signed normal definig the plane
%       points - a 3 x 1 vector, pt defining the plane
%       queryPt - a 3 x 1 vector, pt asking for the pt in the
%                    plane with the minimum distance
%   Outputs:
%       ansPt   - a n x 3 vector, projected points in the plane
%
%% Code
function ansPts = projPoint2Plane(normal,points)

n = size(points,1);
ansPts = zeros(n,3);
for i=1:n
    ansPts = normal*points(i,1:3);
end