%% pointPlane2Point
% Computes the point in a plane with the minimum distance to a 
% given point in the space. The plane is defined with its normal an a point
% inside the plane.
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 08/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%% Usage
%       ansPt = pointPlane2Point(normal,planePt,queryPt)
% 
% Variables:
%   Input:
%
%       normal  - a 3 x 1 vector, signed normal definig the plane
%       planePt - a 3 x 1 vector, pt defining the plane
%       queryPt - a 3 x 1 vector, pt asking for the pt in the
%                    plane with the minimum distance
%   Outputs:
%       ansPt   - a 3 x 1 vector, pt in the plane with the minimum
%                    distance to queryPt
%       d       - an integer, unsigned distance from the pt in the plane to the
%                 queryPt
%% Code
function [ansPt d]= projectPoints2Plane(planePts,planeNormals,queryPts)

d = distPoint2Plane(queryPts,planeNormals,planePts);
% [d inx] = sort(d);
dv = zeros(3,size(planeNormals,2));

dv(1,:) = d.*planeNormals(1,:);
dv(2,:) = d.*planeNormals(2,:);
dv(3,:) = d.*planeNormals(3,:);
% tmp = queryPts-dv;
ansPt = queryPts-dv;