% UNITNORMALSCOS
% Given two normal vector, return the cosine of the angle in radians
% between them
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - Feb, 2009
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage
%      unitNcosA = unitNormalsCos(n1,n2)
%
% Variables
%   Inputs :
%       n1    - a 3xn vector, first normal 
%       n2    - a 3xn vector, second normal
%
%   Outputs:
%       unitNcosA - an integer, cosine of the angle between the unit normals
%
%% Code

function unitNcosA = unitNormalsCos(n1,n2)

% Angle cosine between the unit normals
[n m]= size(n1);

if n ==3
  unitNcosA = sum(n1.*n2,1);
elseif m==3
  unitNcosA = sum(n1'.*n2',1); 
else
  error('Mistmatch dimension for the normals')
  
end