% UNITNORMALSCOS
% Given two normal vector, return the cosine of the angle in radians
% between them
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - Feb, 2009
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage
%      angle = vectors3DAngle(u,v)
%
% Variables
%   Inputs :
%       u    - a 3x1 vector, first vector
%       v    - a 3x1 vector, second vector
%
%   Outputs:
%       angle - an integer, cosine of the angle between the unit normals
%
%% Code

function angle = vectors3DAngle(u,v)

% Angle cosine between the unit normals
[n m]= size(u);
[n1 m1]= size(v);



if (n >3 || n1>3)
  error('Vectors mistmatch dimension')
end
angle = acos(vectors3DAngleCos(u,v));
