%% xyzrpy2H
% Convert a rotation vector containing coordinates (x,y,z) and 
% Euler angles roll pitch and yaw in an homogeneus transformation matrix
%
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - Feb, 2009
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%   poseeuler = xyzrpy2H(pose);
%
% Variables
%   Inputs :
%       pose   - 1 x 6 vector, (x,y,z,Rx,Ry,Rz)
%                   roll: rotation angle about the x axis
%                   pitch: rotation angle about the y axis
%                   yaw: rotation angle about the z axis
%   Ouputs :
%       H       - 4 x 4 matrix, homogeneus trasnformation matrix
%
%
% NOTE: keep in mind the angles description above
%

%% Code
%% xyzrpy2HRT
function H = xyzrpy2H(pose)

H = ([rxryrz2R(pose(1,5),pose(1,5),pose(1,6)) [pose(1,1:3)']; 0 0 0 1]);

