%% XYZRXRYRZ2H
% Convert a 6D vector containing coordinates [x;y;z;rx;ry;rz]
% to a homogeneus transformation matrix
%
%
%% Description
%
% Author -
%         Ernesto Homar Teniente Aviles
%         CONACYT Scholar
%         Institut de Robotica i Informatica Industrial, CSIC-UPC
%         Last change - 09/2010
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
% Usage:
%   poseeuler = xyzrxryrz2HRt(pose);
%
% Variables
%   Inputs :
%       pose   - 6x1 vector, [x;y;z;rx;ry;rz]
%                   rx,roll: rotation angle about the x axis
%                   ry,pitch: rotation angle about the y axis
%                   rz,yaw: rotation angle about the z axis
%   Ouputs :
%       H       - 4 x 4 matrix, homogeneus transformation matrix
%
%
% NOTE: keep in mind the angles description above
%

%% Code
function H = xyzrxryrz2HRt(pose)
szpose = size(pose,2);
switch szpose
  case 1
    t = pose(1:3);
  case 6
    t = pose(1:3)';
end
H = ([rxryrz2R(pose(4),pose(5),pose(6)) t; 0 0 0 1]);