% ANGLE2RZ3D -
% Get the 3D rotation matrix about z axis given an angle
%
%% Description
% Author - 	
%         Ernesto Homar Teniente Aviles
%         CONACYT Scholar
%         Institut de Robotica i Informatica Industrial, CSIC-UPC
%         Last change: 09/2010
%         Version 1.0
%
% Usage:
%       dataRz = angle2Rz3D(angle)
%
% Variables
%  Input:
%       angle  - a real, angle (rad)
%
%  Outputs;
%        Rz - a 3 x 3 matrix, rotated data

%% Code
function Rz = angle2Rz3D(angle)

Rz = [cos(angle) -sin(angle) 0;sin(angle) cos(angle) 0;0 0 1 ];

