% AXISANGLE2QUATERNION -
%
%% Description
%
% Author -
%         Ernesto Homar Teniente Aviles
%         CONACYT Fellow
%         Institut de Robotica i Informatica Industrial, CSIC-UPC
%         Last change: 09/2010
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage
%     q = axisAngle2Quaternion(epsilon)
%
% Varibles:
%   Input
%       epsilon  - a 4x1 vector, rotation vector  or axis angle vector
%
%
%   Output:
%       q   - a 4x1 vector, quaternion
%

%% Code

function q = axisAngle2Quaternion(epsilon)

theta_2 = epsilon(1)/2;
s = sin(theta_2);

q(1) = cos(theta_2);
q(2) = epsilon(2)*s;
q(3) = epsilon(3)*s;
q(4) = epsilon(4)*s;
