% EXPMAP2R
% Compute the rotation matrix from an exponetial map so(3) 
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
%           CONACYT Fellow
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 09/2010
% 
% Usage:
%   R = expMap2R(expo);
%
% Variables
%
% Inputs :
%   rotVec  - a 1 x 3 vector, exponential map [theta*w_x;theta*w_y;theta*w_z]
% 
% Outputs :
%   R       - a 3 x 3 matrix, calculated rotation matrix
% 

%% Code :
function  R = expMap2R(expo)

axisAngle = expMap2AxisAngle(expo);

R = axisAngle2R(axisAngle);

