% Q2R 
% Converts a quaternion in to a rotation matrix
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 08/2009
%			Version 1.0
%
% Usage:
%       R = q2R(q)
%
% Variables
%   Inputs:
%       q - a 1 x 4 vector, quaternion
%
%   Outputs:
%       R - a 3 x 3 matrix, rotation matrix
%
%% Code
function R = q2R(q)

% Rotation matrix from a quaternion

q0 = q(1);
q1 = q(2);
q2 = q(3);
q3 = q(4);

R=[q0^2+q1^2-q2^2-q3^2, 2*(q1*q2-q0*q3), 2*(q1*q3+q0*q2);
   2*(q1*q2+q0*q3), q0^2-q1^2+q2^2-q3^2, 2*(q2*q3-q0*q1);
   2*(q1*q3-q0*q2), 2*(q2*q3+q0*q1), q0^2-q1^2-q2^2+q3^2];
   
   
