% BINSEARCHEXACT -
% Found the index of the 'y' in data equal to  'x'
%
% Description -
% Author:	
%       Ernesto Homar Teniente Aviles
%       CONACYT Fellow
%       Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 11/2010
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% 
% Usage:
%   inx = exbinSearch(x,data)
% 
% Variables:
%   Inputs:
%       x    - a real, value to search
%       data - 1xn vector, data to perfom the binary search
%
%   Outputs: 
%       inx - an integer, index number found, function returns zero when no
%             index was found
%

%% Code:
function inx = binSearchExact(x,data)

% Set Bounds
low_i = 1;
upp_i = size(data,2);

% Finds the lower index by a binary search
while (low_i <= upp_i);
  inx = round((low_i + upp_i)/2);
  if (x < data(inx));
    upp_i = inx - 1;
  elseif (x > data(inx));
    low_i = inx + 1;
  else 
    return
  end
end
% inx = 0;
