%% EXBINSEARCH
% Found the index of the 'y' in DataSet equal to  'x'
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 09/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% Usage
%   cIndex = exbinSearch(x,dataSet)
% Variables:
%   Inputs:
%       x       - a real, value to search
%       dataSet - Data set in which the index containg "y" will be found
%
%   Outputs: 
%       cIndex - an integer, index number on DataSet with the expected
%       value
%
%% Code:
function cIndex = exbinSearch(x,dataSet)

% Set Bounds
low_i = 1;
upp_i = size(dataSet,1);

% Finds the lower index by a binary search
while (low_i <= upp_i);
    cIndex = round((low_i + upp_i)/2);
    % fprintf('\n index : %d value : %12.0f \n', [cIndex dataSet(cIndex,1)])
    if (x < dataSet(cIndex));
        upp_i = cIndex - 1;
        % fprintf('\n upp index : %d value : %12.0f \n', [cIndex dataSet(cIndex,1)]);
    elseif (x > dataSet(cIndex));
        low_i = cIndex + 1;
        % fprintf('\n low index : %d value : %12.0f \n', [cIndex dataSet(cIndex,1)]);
    else 
        % fprintf('x : %12.0f , answer: %12.0f \n', [x dataSet(cIndex,1)])
        return
    end
end
cIndex = 0;


