%% WINDOWBINSEARCH
% Given a data set, finds the firs and alast elements between a central point and a
% reference
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 12/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
%
%% Usage
%   windowBinSearch(dataSet,delta,x)
% Variables
%   Inputs:
%       dataSe 	- a n x 1 matrix, points searching its neighbors
%       delta   - 
%       x       - central value
%
%
% Outputs:
%       [lowindx uppindx] 

%% Code
function [lowindx uppindx] = windowBinSearch(dataSet,delta,x)

vlow =(x-delta);
low_i = 1;
upp_i = size(dataSet,1);
lowindx = round((upp_i)/2);
% Finds the lower index by a binary search
while ((low_i+1) < upp_i);
    
    if dataSet(lowindx) > vlow;
        upp_i = lowindx;
    else dataSet(lowindx) < vlow;
        low_i = lowindx;
    end
    lowindx = round((upp_i+low_i-1)/2);
end

vupp =(x+delta);
low_i = 1;
upp_i = size(dataSet,1);
uppindx = round((upp_i)/2);
% lowindx = round((upp_i+low_i-1)/2);
% Finds the lower index by a binary search
while ((low_i+1) < upp_i);
    if dataSet(uppindx) > vupp;
        upp_i = uppindx;
    else dataSet(uppindx) < vupp;
        low_i = uppindx;
    end
    uppindx = round((upp_i+low_i-1)/2);
end


