% GETCORRMATRIX3D
% Given two data sets compute the correlation matrix between them.
%
%% Description:
%
% Author - 	
%       Ernesto Homar Teniente Aviles
% 			CONACYT Schoolar
%			  Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 11/2010
%       Version 1.01
%
% Usage:
%       SS =  getCorrMatrix3D(dataSet1,dataSet2)
%
% Variables:
%   Inputs:
%       dataSet1 - 3xn matrix, first data set 
%       dataSet2 - 3xn matrix, second data set
%
% 	Outputs:
%		S	- 3 x 3 matrix, correlation matrix between two data sets
%
%   
%

%% Code:

function SS =  getCorrMatrix3D(dataSet1,dataSet2)

SS(1,1) = dataSet1(1,:)*dataSet2(1,:)'; % S.xx
SS(1,2) = dataSet1(1,:)*dataSet2(2,:)'; % S.xy
SS(1,3) = dataSet1(1,:)*dataSet2(3,:)'; % S.xx
SS(2,1) = dataSet1(2,:)*dataSet2(1,:)'; % S.yx
SS(2,2) = dataSet1(2,:)*dataSet2(2,:)'; % S.yy
SS(2,3) = dataSet1(2,:)*dataSet2(3,:)'; % S.yz
SS(3,1) = dataSet1(3,:)*dataSet2(1,:)'; % S.zx
SS(3,2) = dataSet1(3,:)*dataSet2(2,:)'; % S.zy
SS(3,3) = dataSet1(3,:)*dataSet2(3,:)'; % S.zz

 