%% Description
% Function to transform from cartesian coordinates to spherical
%
%% Author - 	
%           Ernesto Homar Teniente Aviles
%			IRI,IOC, Universidad Politcnica de Catalua
% 			CONACYT Scholarship
% Date	 -	Sept, 2007 
% Date	 -	Feb, 2012 
% 
%% Usage:
%
%
% Variables:
%   Input
%       dataxyz - a 3 x n matrix, coordinates [x y z]
%   
%   Otuput
%   c_esf-> [Radius Phi Theta]
%% Code

function [c_esf] = carte2esf(dataxyz)


j = size(dataxyz,2);
r = zeros(j,1);

for i=1:j
    r(i) = norm(dataxyz(i,:));
    
    
    
end
phi = atan(dataxyz(:,2)/dataxyz(:,1));
theta = acos(dataxyz(:,3)/r);

c_esf = [r phi theta];

%     x = dataxyz(i,1);
%     y = dataxyz(i,2);
%     z = dataxyz(i,3);
   % Other eqs. to convert from cart2esf coord.
     %   theta2 = atan(norm(dataxyz(i,1:2))/z);
     %   phi2 = acos(x/(r*sin(theta)));
