function [ data_new ] = applyR2data( data, R )
%APPLYR2DATA Applies a 3D rotation to a set of points
% function [ data_new ] = applyR2data( data, R )
% 
% Inputs:
%       - data  -> [ 3 x N ] Data set
%       - R     -> [ 3 x 3 ] Rotation Matrix
% 
% Outputs:
%       - data_new -> [ 3 x N ] New rotated Data set 
%   Author:
%           Sergi Foix Salmeron
%           PRE-JAE
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - July, 2009
%
% This code has been developed as part of the XXX Project
% 


for ii=1:size(data,2)
    data_new(:,ii) = applyR2point(data(:,ii), R);
end