%% updateRTwH -
% Updates an old homogenus matrix given a new rotation matrix and
% translation vector
%
%% Description
%
% Author - 	
%         Ernesto Homar Teniente Aviles
% 			  CONACYT Schoolarship
%			    Institut de Robotica i Informatica Industrial, CSIC-UPC
%         Last change: 7/2010
%
% Usage
%   RT_h = RT_H(R_new,T_new, RTlast_H)
%
% Variables:
%   Input:
%       R_new   - a 3 x 3 matrix, updating rotation matrix
%       T_new   - a 3 x 1 vector, updating translation vector
%       RTlast_H
%
%   Outputs:
%       RT_h    - a 4 x 4 matrix, resulting homegeneus matrix
%% Code
function RT_h = updateRTwH(R_new,T_new, RTlast_H)
 R = [R_new; 0 0 0];
 T = [T_new; 1];
 RTnew_H = [R T];
 
 RT_h = RTnew_H * RTlast_H;
