%% Description:

% Transform the data set inidcated on index with an RT homogeneous matrix
% 
% Ernesto Homar Teniente Avil�s
% UPC-IRI
% CONACYT, schoolarship
% May 2008
% Variables:
%
% Inputs: 
% 	R 		- a 3 x 3 matrix, rotation matrix
% 	T 		- a 3 x 1 matriz, translation vector
% 	data 	- a n x 3 matrix, containg the data to transform
% 	index 	- a n x 1 matrix, containg the index to the data to transform


% data(i) = 1x3

%% Code:

function New_data = RTdataIndex(data,R,T,index)



if size(index,2) >1

	error('index dimention to big')

end

j = size(index,1);

New_data = zeros(j,3);

% RT homogeneus matrix for transformation

 R = [R; 0 0 0];
 T = [T; 1];
 H = [R T];
    for i=1:j
        data_i = [data(index(i),:)'; 1];
        New_data_i = (H*data_i)';
        New_data(i,:) = New_data_i(1:3);
    end


return