% RY3D -
% Rotate 3D data bout y axis
%
%% Description
% Author - 	
%       Ernesto Homar Teniente Aviles
% 			CONACYT Schoolar
%			  Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 07/2010
%			  Version 1.2
%
% Usage:
%       dataRy = Ry3D(data,theta)
%
% Variables
%  Input:
%       data3D - a (3xn) or (nx3) matrix, contaning the points to rotate
%       angle  - a real, angle (rad)
%
%  Outputs;
%        dataRy - a 3 x n matrix, rotated data

%% Code
function dataRy = Ry3D(data3D,theta)

[n m] =size(data3D);

if m==3
  data3D = [data3D(:,1);data3D(:,2); data3D(:,3)];
end

dataRy = [cos(theta) 0 sin(theta);0 1 0;-sin(theta) 0 cos(theta)]*data3D;

