% RZ3D -
% Rotate 3D data about z axis
%
%% Description
% Author - 	
%       Ernesto Homar Teniente Aviles
% 			CONACYT Schoolar
%			  Institut de Robotica i Informatica Industrial, CSIC-UPC
%       Last change: 07/2010
%			  Version 1.2
%
% Usage:
%       dataRz = Rz3D(data,angle)
%
% Variables
%  Input:
%       data3D - a (3xn) or (nx3) matrix, contaning the points to rotate
%       angle  - a real, angle (rad)
%
%  Outputs;
%        dataRz - a 3 x n matrix, rotated data

%% Code
function dataRz = Rz3D(data3D,angle)

[n m] =size(data3D);

if m==3
  data3D = [data3D(:,1);data3D(:,2); data3D(:,3)];
end


dataRz = [cos(angle) -sin(angle) 0;sin(angle) cos(angle) 0;0 0 1 ]*data3D;

