%% APPLYHRT2DATA -
% Transform a set of data given an homogeneous matrix
%
%% Description
%
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			    CONACYT Schoolarship
%			      Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 7/2010
%
% Modified by:
%           Sergi Foix Salmeron
%           PRE-JAE
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change - July, 2009
% 
% Usage
%   New_data = datah_RT(data,H)
%
% Variables:
% Inputs 
% 	data    - a nx3 or 3xn matrix, containg the data to transform
% 	H     - a 4 x 4 matrix 0r 6x1 vector, homegneus transformation matrix
%
% Output
%   New_data - a n x 3 matrix, containg the transformed data

%% Code
function dataH = applyHRt2data(data,H)

[n m] = size(data);
[n1 m1] = size(H);

if m1 == 6 || n1==6
  pose = H;
  H = ([rxryrz2R(pose(4),pose(5),pose(6)) (pose(1:3)); 0 0 0 1]);
end

if m==3
  data = data';
end

dataR = rotateData3D(data,H(1:3,1:3));
dataH = [dataR(1,:)+H(1,4)
         dataR(2,:)+H(2,4)
         dataR(3,:)+H(3,4) ];

