% TRANSDATAGL2REFZERO -
% Given a poses set , transform each data set element from global to a 
% local  frame centered on [0 0 0 0 0 0]
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 07/2009
%			Version 1.0
%
% Usage:
%       tData = transDatagl2refzero(data,pos)
%
% Variables
%  Input:
%       data - a n x 3 matrix, data to transform
%       pos  - a n x 6 vector, poses
%
%  Outputs;
%       tData - a 3 x n matrix, local data

%% Code

function tData = transDatagl2refzero(data,pos)

RTdataN = ([ypr2R(pos(1,6),pos(1,5),pos(1,4)) (pos(1,1:3)'); 0 0 0 1]);
invRTdataN = inv(RTdataN);
tData = applyHRt2data(data,invRTdataN);
