% DATA3DTRANSLATION -
% Function to translate 3D data
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT scholarship
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 07/2009
%			Version 1.0
%
% Usage:
%       New_data = dataTranslation3D(data,T)
%
% Variables
%  Input:
%       data - a 3 x n matrix, data to translate
%       T    - a 1 x 3 vector, values to translates
%
%  Outputs;
%       New_data - a 3 x n matrix, translated data

%% Code
function New_data = translation3D(data,T)

% Transaltion for a  data set
j = size(data,1);
New_data = [];

for i=1:j;
    New_data(i,:) = data(i,:)+T';
end

return
