%% updateHwRt -
% Updates an old homogenus matrix given a new rotation matrix and
% translation vector
%
%% Description
%
% Author - 	
%         Ernesto Homar Teniente Aviles
% 			  CONACYT Schoolar
%			    Institut de Robotica i Informatica Industrial, CSIC-UPC
%         Last change: 7/2010
%
% Usage
%   updatedH = updateHwRt(R,t, H)
%
% Variables:
%   Input:
%       R   - a 3 x 3 matrix, updating rotation matrix
%       t   - a 3 x 1 vector, updating translation vector
%       H   - last homogeneus trasnformation matrix
%
%   Output:
%       updatedH - a 4 x 4 matrix, resulting homegeneus matrix
%% Code
function updatedH = updateHwRt(R,t, H)
 Rtmp = [R_new; 0 0 0];
 ttmp = [T_new; 1];
 newH = [Rtmp ttmp];
 
 updatedH = newH*H;
