% VONE2VTWOHRT -
% Given two pose vectors (x,y,z,rx,ry,rz), find the homogeneous
% transformation between two poses, this is, from the refence data vector 
% to the model data vector
%
%% Description
% Author - 	
%         Ernesto Homar Teniente Aviles
% 			  CONACYT Schoolar
%			    Institut de Robotica i Informatica Industrial, CSIC-UPC
%         Last change: July, 2010
%
% Usage :
%       H = one2otherH(refPose,modPose);
% Variables:
%   Inputs:
%       refVector - a 1 x 6 matrix (x,y,z,rx,ry,rz), reference data 
%       modVector - a 1 x 6 matrix (x,y,z,rx,ry,rz), model data

function H = vone2vtwoHRt(refPose,modPose)


Hvector1 = xyzrxryrz2HRt(refPose);
Hvector2 = xyzrxryrz2HRt(modPose);
H = inv(Hvector1)*Hvector2;
