
#include <math.h>
#include "mex.h"
#include <stdio.h>
#include <iostream>  // I/O 
#include <fstream>   // file I/O
#include <vector>

using namespace std;



// main function
mxArray *process(const mxArray *mxMA, const mxArray *mxMB, const mxArray *mxMC)
{

	
	double *ma = (double *)mxGetPr(mxMA);
	double *mb = (double *)mxGetPr(mxMB);
  double *mc = (double *)mxGetPr(mxMC);
	const int *mSize = mxGetDimensions(mxMA);
//   Matrix *qPts = (Matrix *)mxGetPr(mxMA);
//   Matrix *rPts = (Matrix *)mxGetPr(mxMB);

	int out[2];
	out[0] = 1;
	out[1] = mSize[1];
  // output 
  mxArray *mxSal = mxCreateNumericArray(2, out, mxDOUBLE_CLASS, mxREAL);
  double *sal = (double *)mxGetPr(mxSal);
//   mb_dist2(ma,mb,out[1],*(mc));
  
  /****************************************************************************/
  int L =*mc;
  double M[3][3];
  double k;
  double L_i;
  double L2 = L*L;
  double k_;
  double d_i;
  double d[mSize[1]];
  int x,y,z;
  for (int i = 0; i < mSize[1]; ++i){
    
    double q_i[2],r_i[2],d_[2];
    
    x = 0 + i*3;
    y = 1 + i*3;
    z = 2 + i*3;
    
    q_i[0] =*(ma+x);
    q_i[1] =*(ma+y);
    q_i[2] =*(ma+z);
    
    r_i[0] =*(mb+x);
    r_i[1] =*(mb+y);
    r_i[2] =*(mb+z);
    // delta
    d_[0] = r_i[0]-q_i[0];
    d_[1] = r_i[1]-q_i[1];
    d_[2] = r_i[2]-q_i[2];
    
    k_ =  sqrt(q_i[0]*q_i[0]+ q_i[1]*q_i[1]+ q_i[2]*q_i[2]);
    k = k_*k_+L2;
    L_i = L2/k;
    // Compute M
    
    M[0][0] = r_i[0]*r_i[0]/k+L_i;
    M[0][1] = r_i[0]*r_i[1]/k;
    M[0][2] = r_i[0]*r_i[2]/k;
    M[1][0] = M[0][1];
    M[1][1] = r_i[1]*r_i[1]/k+L_i;
    M[1][2] = r_i[1]*r_i[2]/k;
    M[2][0] = M[0][2];
    M[2][1] = M[1][2];
    M[2][2] = r_i[2]*r_i[2]/k+L_i;

    d_i = d_[0]*(M[0][0]*d_[0]+M[0][1]*d_[1]+M[0][2]*d_[2])+
        d_[1]*(M[1][0]*d_[0]+M[1][1]*d_[1]+M[1][2]*d_[2])+
        d_[2]*(M[2][0]*d_[0]+M[2][1]*d_[1]+M[2][2]*d_[2]); 
    *(sal + i) = d_i;    
  }
  /****************************************************************************/

  
/*  
 for (int i=0;i<out[1];i++){
   *(sal + i) = d_v[i];
  }*/
  return mxSal;
  
}


/** this function computes the metric base distance between two 3D data sets with 
the same size*/
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) { 
    if (nrhs < 3)
       mexErrMsgTxt("Tree inputs requiered"); 
    else if(nrhs > 3)
      mexErrMsgTxt("Too many input arguments.");
    plhs[0] = process(prhs[0],prhs[1],prhs[2]);

      

}



