#include "mex.h"
#include <math.h>
#include <stdio.h>
#include <fstream>   // file I/O
#include <string>
#include <iostream>
#include <string.h>   // Required by strcpy()
#include <stdlib.h>   // Required by malloc()

#include "newmat/newmatap.h"
#include "newmat/newmat.h"
#include "newmatio.h"

// ReturnMatrix repPoints(double *data,int dim,int n_data, int n_times){
//  
//   
//   Matrix M(dim ,n_times*n_data);
//   cout << "N times:"<<n_times<< endl<< endl;
//   Real pt[dim];
//   for (unsigned int i=0; i<n_data;i++){
//     for (unsigned int j=0;j<dim;j++){
//       pt[j] = *(data +j+i*dim);
//     }
//     for (unsigned int j=0;j<n_times;j++){
//     M.Column(j+1+i*n_times) << pt;
//     }
//   }
//   M.Release(); 
//   return M;
// }


ReturnMatrix repPoints(double *data,int dim,int n_data, int n_times){
 
  ColumnVector M(dim*n_data*n_times);
  Real m[dim*n_data*n_times];
 
  for (unsigned int i=0; i<n_data;i++){
    for (unsigned int j=0;j<n_times;j++){
      for (unsigned int k=0;k<dim;k++){
        m[k+j*dim+i*n_times*dim] =*(data+k+i*dim);
      }
    }
  }
  M << m;
  M.Release(); 
  return M;
}


// main function
mxArray *process(const mxArray *mxMA, const mxArray *mxMB) {

  
  double *ma = (double *)mxGetPr(mxMA);
  double *mb = (double *)mxGetPr(mxMB);

  const int *maSize = mxGetDimensions(mxMA);
  // output size
  int out[2];
  out[0] = maSize[0];
  out[1] = *(mb)*maSize[1];
  double m[out[0]*out[1]];
  
  ColumnVector M;
  M = repPoints(ma,out[0],maSize[1] ,*mb);

  //Output memalloc
  mxArray *mxSal = mxCreateNumericArray(2, out, mxDOUBLE_CLASS, mxREAL);
  double *sal = (double *)mxGetPr(mxSal);

  for (unsigned int i=0;i<out[1]*out[0]; i++){
     *(sal + i) = M.element(i);
   }
  
  return mxSal;
}

using namespace std;
/* this function computes HoG over an input integral image (of oriented gradients) */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) { 
  /**@prhsAn - array of right-hand input argument*/
  /**@plhsAn - array of left-hand output arguments.*/
  /**@nrhs - The number of right-hand arguments, or the size of the prhs
             array.**/  
  /**@nlhs - The number of left-hand arguments, or the size of the
             plhs array.*/
  
    if (nrhs != 2)
       mexErrMsgTxt("incorrect inputs : 1->img 2->cell size"); 
    plhs[0] = process(prhs[0],prhs[1]);


}



