% BOXCFRAME
% Box coordinate frame origin an limits in (x,y,z)
%
% Inputs:
%   b - box bounds computed with boxBounds
%
% Outputs:
%   bcf - a struct, box cordinate frame
%         fields : o,x,y,z (see figure)
%        ______
%       |\     \
%       | \ z   \
%      y|  \_____\
%        \  |_|_|_|
%         \ |_|_|_|
%          \|_|_|_|
%         o      x
%
%
function bcf = boxCFrame(b)

bcf.o = [b.min(1);b.min(2);b.min(3)];
bcf.x = [b.max(1);b.min(2);b.min(3)];
bcf.y = [b.min(1);b.max(2);b.min(3)];
bcf.z = [b.min(1);b.min(2);b.max(3)];