function I =boxesAccess(data,boxsize,boxcframe)

% Compute corresponding bos for each point respect to a referece boxs
% structure according with Acka_
% Author - 	Ernesto Homar Teniente AViles
%           Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 2011/03/08
%               Date:
%               Author:
%			          Version 1.0
% Usage:
%   I -boxesAccess(data,boxsize,boxcframe)
%  
% Inputs:
%     data - 3xn matrix,
%     boxsize - a + real
%     boxcframe - a struc with information  about the boounding box in the
%                 reference data 
%


ndata = size(data,2);

O.X = boxcframe.x-boxcframe.o;
O.Y = boxcframe.y-boxcframe.o;
O.Z = boxcframe.z-boxcframe.o;
D.x = norm(O.X)*boxsize;
D.y = norm(O.Y)*boxsize;
D.z = norm(O.Z)*boxsize;

O.A = (data-boxcframe.o(:, ones(ndata, 1)))';

I = zeros(ndata,3);
I(:,1) = ceil(O.A*O.X/D.x)';
I(:,2) = ceil(O.A*O.Y/D.y)';
I(:,3) = ceil(O.A*O.Z/D.z)';