function C = boxesNNMatch(rPts,rData,qPts,boxsize,metric,L)

% Usage:
%   C = boxesNNMatch(rPts,rData,qPts,boxsize,metric,L)
%
% Inputs:
%   rPts  - 3xn, reference points
%   rData - a struct with information about the boxes structure 
%   qPts  - 3xn, query points
%   metric - a string, metric to find the neares neighbor ('Euclidean' or
%           'Mb')
%   L - parameter to the metrci base distance
% 
% Outputs: 
%   C - 3xn matrix, correspondeces indexs and distance between them
%


delta = 0.1;

qData =  getBoxAccessMine(qPts,boxsize,rData.boxCFrame);
% para todas las caja en qData encontrar su similar en rData
% find NN
C =[];
mqPts= 1; ceil(7*log(boxsize*10.5620)/3);
if mqPts>2
  mqPts = mqPts-2;
end
mrPts= ceil(mqPts/2);
qPts_or= qPts(:,qData.inx);

[ru,rv,rw] = size(rData.I);

for i=1:size(qData.I,1);
  ui =qData.boxes(i,1);
  vi =qData.boxes(i,2);
  wi =qData.boxes(i,3);
  if ui>ru
    ui =ru;
  elseif ui<1
    ui=1;
  end
  if vi> rv
    vi =rv;
  elseif vi<1
    vi=1;
  end
  if wi> rw
    wi =rw;
  elseif wi<1
    wi =1;
  end
  
  inx_=  rData.I(ui,vi,wi);
  nrprts = rData.B(ui,vi,wi) ;
  if  mrPts < nrprts 
      if mqPts<qData.B(i)
%       fprintf('rBox.B  %d, qNPts:%d\n', rBox.B(qData.I(i,1),qData.I(i,2),qData.I(i,3)), ...
%       tmp.npts(i));
      rPts_inx = inx_:(inx_+nrprts -1);
      rPts_ = rPts(:,rData.L2(rPts_inx));
      qPts_inx = qData.I(i):qData.I(i)+qData.B(i)-1;
      qPts_ = qPts_or(:,qPts_inx);
      xC= nnSearchBasic_c(rPts_,qPts_,metric,L);
      % Recover original index
      C = [C [ rPts_inx(xC(1,:));qPts_inx;xC(3,:)]];
      % Visual validation
%         O = rData.boxCFrame.o'+ ...
%              [(ui-1)*boxsize, ...
%               (vi-1)*boxsize, ...
%               (wi-1)*boxsize];
%         voxel(O,[boxsize boxsize boxsize],'r',0.01);
%         plotData3D(rPts_,'MarkerSize',7);
%         plotData3D(qPts_,'Color','r','Marker','*');
%         ptsC = [rPts_(:,xC(1,:));qPts_(:,xC(2,:))];
%         plotCorrespondences3D(ptsC);
%       end
      end
  end
end

% recover original indexs
C(1,:) = rData.L2(C(1,:));
C(2,:) = qData.inx(C(2,:));
