function S = getBoxAccessMine(data,boxsize,boxCframe)

% Ernesto Homar Teniente Aviles
%
% Usage:
%   S = getBoxAccessMine(data,boxsize,boxCframe,delta)
%
% Inputs:
%   qPts - 3xn, query pts
%   boxsize - a +real
%   rData   -
%   delta   - a +real, delta for bounding box
% 
% Outputs: 
%   S - a struct, with fields
%         I - n vector, index pointing first element in the orderes points
%               wich belong to the i-esim box
%         B - n vector, number of points in the i-esim occupied box
%         boxes - nx3 matrix , occupied boxes indices  u v w
%         inx - n vector, indexs to order the point per box
%


% Compute boxes
boxes = boxesAccess(data,boxsize,boxCframe);

[occup ignore S.inx]=  boxesOccupiedandSort(boxes);
S.boxes =occup.boxes;
S.I = occup.inx.first;
S.B = occup.npts;



% % compute box information
% info =boxBounds(data, delta);
% % m =boxesQuantity(info.delta,boxsize);
% m(1) = max(boxes(:,1));
% m(2) = max(boxes(:,2));
% m(3) = max(boxes(:,3));
% % Fill up matrices I and B
% S.I = zeros(m(1),m(2),m(3));
% S.B = zeros(m(1),m(2),m(3));
% 
% for i=1:size(boxes,1)
%   % number of points in each box
%   S.B(boxes(i,1),boxes(i,2),boxes(i,3)) = S.B(boxes(i,1),boxes(i,2),boxes(i,3))+1;
% end
% 
% count = 1;
% for u=1:m(1)
%   for v=1:m(2)  
%     for w=1:m(3)
%       if u > 1 || v>1 || w > 1
%         if S.B(u,v,w)
%           S.I(u,v,w) = count;
%           count = count+S.B(u,v,w);
%         end
%       end
%     end
%   end
% end
% 
% % Filling L2
% S.B = zeros(m(1),m(2),m(3));
% % 
% S.L2 = zeros(1,size(boxes,1));
% for i=1:size(boxes,1)
%   inx =S.I(boxes(i,1),boxes(i,2),boxes(i,3))+S.B(boxes(i,1),boxes(i,2),boxes(i,3));
%   S.B(boxes(i,1),boxes(i,2),boxes(i,3))= S.B(boxes(i,1),boxes(i,2),boxes(i,3))+1;
%   S.L2(inx) = i; 
% end
% S.boxCFrame = boxCFrame(info);
% S.bounds =info;
% S.nBoxes= m;