function c = nnSearchBasic(rData,qData,varargin)

% Usage:
%   c = nnSearchBasic(rData,qData[,OPTIONS])
%   c = nnSearchBasic(rData,qData,'Mb'[,OPTIONS])
%   c = nnSearchBasic(rData,qData,'Mb',L)
%
% Input:
%
%   Options:
%       1.- Metric - a string, 'Euclidean'(DEFAULT), or 'Mb'
%       2.- L     - a +integer, 3(DEFAULT), it is necessary when using Mb
%
% Output:
%   c = 2xm matrix, correspondences index (rIndex,qIndex)
%
metric = 'Euclidean';
L = 3;
if nargin >= 3
  metric = varargin{1};
end
if nargin == 4;
  L = varargin{2};
end

rData_n = size(rData,2);
qData_n = size(qData,2);
c = zeros(3,qData_n);
% if rData_n >5
%   pause(1);
% end
%   Repeat reference data for computing NN local brute force
mind = [1;2;3];
nind = (1:rData_n)';
mind = mind(:,ones(1,1));
nind = nind(:,ones(1,qData_n));
rData = rData(mind,nind);

% Repeat query points
% fprintf('r = %d\t ,q: %d\n',rData_n,qData_n)
if rData_n >1
 qData_ = repVecColData(qData,rData_n);
else
  qData_ = qData;
end
% else
%   a(1) =1;
%   a(2) =rData_n;
%   qData_ = zeros(3,qData_n*rData_n);
% 
%   for i=1:qData_n
%     A =qData(:,i);
%     qData_(:,a(1):a(2)) = A(:, ones(rData_n, 1));
%     a(1) = a(2)+1;
%     a(2) = a(1)+rData_n-1;
%   end
% end
%%

switch metric
  case 'Euclidean'
    dpp =  dist3D(qData_,rData);
  case 'Mb'
    dpp = MbDistc(qData_,rData,L);
  otherwise
   error('Invalid or not implemented distance metric') 
end
c(2,:) =1:qData_n;
a(1) =1;
a(2) =rData_n;
 for i=1:qData_n
     [c(3,i) c(1,i)]= min(dpp(:,a(1):a(2)));
     a(1) = a(2)+1;
     a(2) = a(1)+rData_n-1;
end