function [ fig ] = plotCovGraphs( covMean, corrCov, sd, res )
%PLOTCOVGRAPHS Summary of this function goes here
%   Detailed explanation goes here

%% Creació de la figura i els subplots
fig.handle = figure;hold on;
% set(fig.handle,'color','white');
fig.sp1 = subplot(3,5,1); axis(fig.sp1,'equal'); title('X-Y Covariance');xlabel('meters (X)');ylabel('meters (Y)');
fig.sp2 = subplot(3,5,2); axis(fig.sp2,'equal'); title('X-Z Covariance');xlabel('meters (X)');ylabel('meters (Z)');
fig.sp3 = subplot(3,5,3); axis(fig.sp3,'equal'); title('X-Phi Covariance');xlabel('meters (X)');ylabel('radians (\phi)');
fig.sp4 = subplot(3,5,4); axis(fig.sp4,'equal'); title('X-Theta Covariance');xlabel('meters (X)');ylabel('radians (\theta)');
fig.sp5 = subplot(3,5,5); axis(fig.sp5,'equal'); title('X-Psi Covariance');xlabel('meters (X)');ylabel('radians (\psi)');
fig.sp6 = subplot(3,5,6); axis(fig.sp6,'equal'); title('Y-Z Covariance');xlabel('meters (Y)');ylabel('meters (Z)');
fig.sp7 = subplot(3,5,7); axis(fig.sp7,'equal'); title('Y-Phi Covariance');xlabel('meters (Y)');ylabel('radians (\phi)');
fig.sp8 = subplot(3,5,8); axis(fig.sp8,'equal'); title('Y-Theta Covariance');xlabel('meters (Y)');ylabel('radians (\theta)');
fig.sp9 = subplot(3,5,9); axis(fig.sp9,'equal'); title('Y-Psi Covariance');xlabel('meters (Y)');ylabel('radians (\psi)');
fig.sp10 = subplot(3,5,10); axis(fig.sp10,'equal'); title('Z-Phi Covariance');xlabel('meters (Z)');ylabel('radians (\phi)');
fig.sp11 = subplot(3,5,11); axis(fig.sp11,'equal'); title('Z-Theta Covariance');xlabel('meters (Z)');ylabel('radians (\theta)');
fig.sp12 = subplot(3,5,12); axis(fig.sp12,'equal'); title('Z-Psi Covariance');xlabel('meters (Z)');ylabel('radians (\psi)');
fig.sp13 = subplot(3,5,13); axis(fig.sp13,'equal'); title('Phi-Theta Covariance');xlabel('Rx - radians (\phi)');ylabel('Ry - radians (\theta)');
fig.sp14 = subplot(3,5,14); axis(fig.sp14,'equal'); title('Phi-Psi Covariance');xlabel('Rx - radians (\phi)');ylabel('Rz - radians (\psi)');
fig.sp15 = subplot(3,5,15); axis(fig.sp15,'equal'); title('Theta-Psi Covariance');xlabel('Ry - radians (\theta)');ylabel('Rz - radians (\psi)');

h=plot_gaussian_ellipsoid([covMean(1) covMean(2)]', corrCov.xy, sd, res, fig.sp1); set(h,'color','black');
plot(fig.sp1,covMean(1), covMean(2), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(1) covMean(3)]', corrCov.xz, sd, res, fig.sp2); set(h,'color','black');
plot(fig.sp2,covMean(1), covMean(3), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(1) covMean(4)]', corrCov.xphi, sd, res, fig.sp3); set(h,'color','black');
plot(fig.sp3,covMean(1), covMean(4), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(1) covMean(5)]', corrCov.xtheta, sd, res, fig.sp4); set(h,'color','black');
plot(fig.sp4,covMean(1), covMean(5), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(1) covMean(6)]', corrCov.xpsi, sd, res, fig.sp5); set(h,'color','black');
plot(fig.sp5,covMean(1), covMean(6), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(2) covMean(3)]', corrCov.yz, sd, res, fig.sp6); set(h,'color','black');
plot(fig.sp6,covMean(2), covMean(3), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(2) covMean(4)]', corrCov.yphi, sd, res, fig.sp7); set(h,'color','black');
plot(fig.sp7,covMean(2), covMean(4), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(2) covMean(5)]', corrCov.ytheta, sd, res, fig.sp8); set(h,'color','black');
plot(fig.sp8,covMean(2), covMean(5), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(2) covMean(6)]', corrCov.ypsi, sd, res, fig.sp9); set(h,'color','black');
plot(fig.sp9,covMean(2), covMean(6), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(3) covMean(4)]', corrCov.zphi, sd, res, fig.sp10); set(h,'color','black');
plot(fig.sp10,covMean(3), covMean(4), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(3) covMean(5)]', corrCov.ztheta, sd, res, fig.sp11); set(h,'color','black');
plot(fig.sp11,covMean(3), covMean(5), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(3) covMean(6)]', corrCov.zpsi, sd, res, fig.sp12); set(h,'color','black');
plot(fig.sp12,covMean(3), covMean(6), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(4) covMean(5)]', corrCov.phitheta, sd, res, fig.sp13); set(h,'color','black');
plot(fig.sp13,covMean(4), covMean(5), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(4) covMean(6)]', corrCov.phipsi, sd, res, fig.sp14); set(h,'color','black');
plot(fig.sp14,covMean(4), covMean(6), '.k', 'markerSize', 10);
h=plot_gaussian_ellipsoid([covMean(5) covMean(6)]', corrCov.thetapsi, sd, res, fig.sp15); set(h,'color','black');
plot(fig.sp15,covMean(5), covMean(6), '.k', 'markerSize', 10);